%% ZMENY V GRAFICKEM SYSTEMU R2014b

%% NOVY GRAFICKY VZHLED

figure
% nove poradi barev
plot(rand(10,3))
% vyhlazovani car a fontu
% hf = gcf;
% hf.GraphicsSmoothing = 'off';
% ha = gca;
% ha.FontSmoothing = 'off';

% barva mrizky
grid on
% ha.GridColor = [0,0,0];
% ha.GridAlpha = 1;
% ha.GridLineStyle = ':'; % uz bylo drive

% velikost titulku a popisku
title('Tri cary')
xlabel('osa x');
ylabel('osa y');

disp(ha.TitleFontSizeMultiplier) % vychozi: 1.1
disp(ha.LabelFontSizeMultiplier) % vychozi: 1.1

% ha.TitleFontSizeMultiplier = 1;
% ha.LabelFontSizeMultiplier = 1;
% ha.TitleFontWeight = 'normal'; % vychozi: 'bold'

% rotovatelne popisky os
disp(ha.XTickLabelRotation) % vychozi: 0

ha.XTickLabelRotation = 60;
ha.YTickLabelRotation = 90;

% TEX interpreter 'none', 'tex', 'latex': lze nastavit vlastnosti Axesu
ha.TickLabelInterpreter

%% Samostatna colormap pro kazdy Axes
figure;
subplot(2,1,1)
peaks;
ax1 = gca;
colorbar

subplot(2,1,2)
peaks;
ax2 = gca;
colorbar

% spolecna colormap
colormap('jet')

% samostatna colormap
colormap(ax1,'hot')
colormap(ax2,'parula')

%% Automaticky aktualizovane datove znacky pri zoomovani

Y = 2005:2014;
M = 1;
D = 1;
t = datetime(Y,M,D);

figure
plot(t,rand(size(Y)))

% zoomovat ve figure > meni se popisky na roky .. mesice .. dny .. hodiny

%% Orezavani 3-D grafu krychli

figure
peaks
axis([-3 3 -3 3 -2 2])

view(-37.5000,60)

% Zruseni orezu
ax = gca;
ax.Clipping = 'off';

%% HANDLE NA GRAFICKE OBJEKTY
% Handle na graficke prvky jsou OBJEKTY, nikoliv DOUBLE

% Pristup k vlastnostem grafickych objektu

%   teckova notace
figure
h = plot(1:10);
h.Color = 'red';

%   funkce set a get (pro skupinove zmeny hodnot)
figure
h = plot(rand(4)); % h je pole grafickych objektu
set(h,'LineWidth',2);

%% Graphics Handle Arrays - pole grafickych objektu

h = gobjects(3,1); % predalokace
h(1) = figure;
h(2) = plot(1:10);
h(3) = gca;

% Do jednoho pole lze kombinovat i graficke handle ruznych typu

class(h)

h(1)
h(2)
h(3)

%% Odkaz na figure celociselnou hodnotou
% volani figure(num) funguje stejne, jako drive. h = figure vsak nevraci
% num, ale objekt. Num je vlastnost h.Number

h = figure; % object handle
num = h.Number % integer handle

figure(h) % vyvolani okna
figure(num) % vyvolani okna

%% Handle na Root

hr = groot % objekt handle na root

%% prikaz Hold on
% funguje jako hold all v predchozich verzich, tedy pri dalsim volani
% prikazu plot se automaticky meni barvy grafu

figure
plot(1:10);
hold on
plot(11:20);
plot(21:30);
hold off

%% zmenseni titulku grafu

% TitleFontSizeMultiplier - zvetsuje nadpis, vychozi je 1.1
figure
plot(1:10);
title('This is a title that is too long and does not fit within the extents of the figure window.')

% Zmenseni
ax = gca;
ax.TitleFontSizeMultiplier = 1;
ax.TitleFontSizeMultiplier = 0.7;

%% Postupne vykreslovani grafu: nova funkce animatedline

theta = linspace(0,2*pi,10000);
figure
h = animatedline();
h.Color = [1 0 0];
axis([0,2*pi,-1,1])
for t = theta
    addpoints(h,t,sin(t));
    drawnow update;
end

%% Soubezne zobrazeni oken
% Pri vytvareni vice oken figure ve skriptu se u starsich verzi cekalo na
% zobrazeni kazdeho okna na obrazovce pred tim, nez se ve skriptu
% pokracovalo. V soucasne verzi se jiz neceka a tak muze byt skript
% proveden do konce a okna se prubezne postupne zobrazuji. 
% 
% Pokud chcete toto chovani vratit na puvodni a cekat na zobrazeni kazdeho
% okna, pouzjte drawnow.

for k = 1:10
    figure
    plot(rand(1,10));
%     drawnow
end
disp('hotovo')

% close all

%% Popisky os reckymi pismeny

x = 0:pi/20:2*pi;
y = sin(x);

figure
plot(x,y)
axis tight
ax = gca;
ax.XTick = 0:pi/2:2*pi;
ax.XTickLabel = {'0','\pi/2','\pi','3\pi/2','2\pi'};
